%SHORT TIME FOURIER TRANSFORM
%WRITTEN IN 1994, UPDATED ON 05/29/1996
%ROBI POLIKAR, IOWA STATE UNIVERSITY, AMES, IOWA

close all
clear

t=0.01:0.001:0.3;
fff1=cos(2*pi*300*t);end

t=0.3:0.001:0.6;
fff2=cos(2*pi*200*t);end

t=0.6:0.001:0.8;
fff3=cos(2*pi*100*t);end

t=0.8:0.001:1.006;
fff4=cos(2*pi*50*t);end

f=[fff1 fff2 fff3 fff4 ];

figure
plot(f)

%t1=0:0.001:0.999;
%ff2=cos(2*pi*50*t1)+cos(2*pi*250*t1);
%plot(ff2)
%axis([0 100 min(ff2) max(ff2)])

w=zeros(size(1:1000));
STFT=zeros(1000,99);
to=-500;
t2=-499:500;
a=0.001;
for tt=1:99;
        w=exp(-a*((t2-to).^2)/2);
        STFT(:,tt)=abs(fft((f.*w)'));
        w=zeros(size(1:1000));
        to=to+10;
end

figure(2)
to=0;
w1=exp(-a*((t2-to).^2)/2);
t3=1:600;
plot(t3,w1(251:850))
figure(3)
mesh(STFT(1:10:1000,1:3:99))

