%04/17/1995

%CONTINUOUS WAVELET TRANSFORM SCHEME

close all
clear
%t=0:0.001:0.249;
%%s1=cos(2*pi*20*t);
%s2=cos(2*pi*50*t);
%s3=cos(2*pi*100*t);

%f=[s1 s2 s3];
t=0.01:0.001:0.3;
fff1=cos(2*pi*30*t);end

t=0.3:0.001:0.6;
fff2=cos(2*pi*20*t);end

t=0.6:0.001:0.8;
fff3=cos(2*pi*10*t);end

t=0.8:0.001:1.006;
fff4=cos(2*pi*5*t);end

f=[fff1 fff2 fff3 fff4 ];



%load cwt_data1.mat

%f=m;
plot(f)




filesize=input('Please enter the filesize:');
timestepsize=input('Please enter the time step size: ');
scalestepsize=input('Please enter the scale step size: ');


numberofsteps=filesize/timestepsize; 
integral=zeros(1,numberofsteps);
scale=input('Please enter the max scale: ');
WT=zeros(scale/scalestepsize,numberofsteps);
%to=-255;
%t1=-255:256;
to=-(filesize/2)+1;
t1=(-filesize/2)+1:filesize/2;
a=1;
counter=1; 
sig=1;
for sig=1:scalestepsize:scale;
  %numberofsteps=round(512/stepsize(s));
    for n=1:numberofsteps
    %    morlet=exp(-i*((t1-to)/(0.2*s))-(((t1-to)/(0.2*s)).^2)/2);
      mex=exp(-(t1-to).^2/(2*sig^2)).*(((t1-to).^2/sig^2)-1);
        ff=f.*(mex); 
        integral(n)=sum(ff);
        to=to+timestepsize;     
     end   
       WT(counter,:)=(1./sqrt(sig))*integral; 
      % WT(counter,:)=integral; 
       sig      
       to=-(filesize/2)+1;
       integral=0;
       counter=counter+1;
end

clf
 mesh((WT));
%figure
%mesh(real(WT))
%title('CWT OF THE TEST INPUT SIGNAL')
ht4=text(0,0,'TRANSLATION');
set(ht4,'units', 'centimeters','position',[9 0.3],'color',[1 1 1])
set(ht4,'fontsize',12)
ht3=text(0,0,'SCALE');
set(ht3,'units', 'centimeters','position',[1 0.3],'color',[1 1 1])
set(ht3,'fontsize',12)
zlabel('AMPLITUDE')



ht=text(0,0,'All Rights Reserved, Robi Polikar, Ames, Iowa, 1996');
set(ht,'units', 'centimeters','position',[0 -1.1],'color',[1 0.1 0.2])
set(ht,'fontname','courier','fontsize',11,'fontangle','italic')
ht2=text(0,0,'THE WAVELET TUTORIAL');
set(ht2,'units', 'centimeters','position',[3.5 -0.7],'color',[0 0.7 0.3])
set(ht2,'fontname','bold','fontsize',12,'fontangle','italic')
grid on




